' ------------------------------------------------------------------------
' String Table (vesechny texty krome Info() )
' ------------------------------------------------------------------------
const str100 = "Npovda"
const str101 = "OKO Setup"
const str102 = "Provedeno nastaven pro OCR FineReader, verze 14."

' ------------------------------------------------------------------------
' Funkce Info vraci jako svuj vysledek informaci o aktualnim souboru
' ------------------------------------------------------------------------
function Info()
	Info = "Nastaven Asistenta pro OCR FineReader verze 14."
end function

' ------------------------------------------------------------------------
' Funkce kopiruje soubor a zrusi mu atribut ReadOnly
' ------------------------------------------------------------------------
function CopyFileNoReadOnly(fso, fSource, fDest)
	call fso.CopyFile(fSource, fDest)
	fName = fso.GetFileName(fSource)
	Set f = fso.getFile(fDest & fName)
	f.Attributes = (f.Attributes And &hfffe)
end function

' ------------------------------------------------------------------------
' Funkce Install provede instalaci
' ------------------------------------------------------------------------
function Install(arg)
	'--------------------------------
	On Error Resume next
	'--------------------------------
        Set fso = CreateObject("Scripting.FileSystemObject")

	LANG = "\cs"
	if arg.count > 0 then
		LANG = arg(0)
	end if
	if LANG = "*" then LANG = "\cs"

	if arg.count > 1 then
		AppDir = arg(1)
	end if
	'--------------------------------
	Set WSHShell = WScript.CreateObject("WScript.Shell")
	'--------------------------------
	Dim regPath
	'regPath = "HKCU\SOFTWARE\ELVOS\Common\"
	'call WSHShell.RegWrite(regPath & "ScannerType", "2")

  regPath = "HKCU\SOFTWARE\ELVOS\FineScan\Set\"
	call WSHShell.RegWrite(regPath & "MainClassName", "FineReader14MainWindowClass")

	'check OS architecture'
	Dim WshProcEnv 
  Dim system_architecture 
  Dim process_architecture 
  Dim PRG_FILES
  Set WshProcEnv = WshShell.Environment("Process") 
 
  process_architecture= WshProcEnv("PROCESSOR_ARCHITECTURE")  
 
  If process_architecture = "x86" Then     
      system_architecture= WshProcEnv("PROCESSOR_ARCHITEW6432") 
      If system_architecture = ""  Then     
          system_architecture = "x86" 
      End if     
  Else     
      system_architecture = process_architecture     
  End If
  
  'msgbox("Arch: " & system_architecture)
  if system_architecture = "x86" then
    PRG_FILES = "program files"
  else
    PRG_FILES = "program files (x86)"
  end if
  '-----------create shortcut in programs-------------
   'v2.2. storage
   AsData = WshShell.ExpandEnvironmentStrings("%AppData%") & "\ACE Design\Asistent\v2.2\Asist\menu"
   sPrograms = AsData & "\Skenovn(2)" 

   'create folder (Asistent group does not exists in user profile)
   if not(fso.FolderExists(sPrograms)) then fso.CreateFolder(sPrograms)

   call fso.DeleteFile(sPrograms & "\*(1).lnk")   
   call fso.DeleteFile(sPrograms & "\*(2).lnk")  

   set oSLink = WSHShell.CreateShortcut(sPrograms & "\FineScan(1).lnk")
   oSLink.TargetPath = WSHShell.RegRead("HKCU\Software\Elvos\Common\Path")  & "\oko\finescan.exe"
   oSLink.Description = "usnadnn snmn text"
   oSLink.Save

   set oSLink = WSHShell.CreateShortcut(sPrograms & "\FineReader(2).lnk")
   oSLink.TargetPath = "C:\" & PRG_FILES & "\ABBYY FineReader 14\FineReaderOCR.exe"
   oSLink.Description = "OCR program"
   oSLink.Save

'//-----------create shortcut in programs-------------

	regPath = "HKCU\SOFTWARE\ELVOS\FineScan\Set\"
	call WSHShell.RegWrite(regPath & "RecPath", "C:\" & PRG_FILES & "\ABBYY FineReader 14\")
	call WSHShell.RegWrite(regPath & "RegBatchPath", "\ABBYY\FineReader\12.00\Batches\Default\")
	
  call WSHShell.RegWrite(regPath & "RegScenariosPath", "\ABBYY\FineReader\14.00\FineReaderShell\")
	
  call WSHShell.RegWrite(regPath & "WorkImgFile", WshShell.ExpandEnvironmentStrings("%USERPROFILE%") & "\appdata\local\oko\WorkImgFile.bmp")
  
	'call WSHShell.RegWrite(regPath & "PageFilePath", "C:\windows\temp\oko\page.txt")
	
	'copy files:
	Set fso = Wscript.CreateObject("Scripting.FileSystemObject")
  'finescan.exe
  fSource = AppDir & "\Accessories" & LANG & "\frset\fr14\finescan.exe"	
	fDest = WSHShell.RegRead("HKCU\Software\Elvos\Common\Path")  & "\oko\finescan.exe"
	call CopyFileNoReadOnly(fso, fSource, fDest)


'msaadll.dll
  fSource = AppDir & "\Accessories" & LANG & "\frset\fr14\msaadll.dll"	
	fDest = WSHShell.RegRead("HKCU\Software\Elvos\Common\Path")  & "\oko\msaadll.dll"
	call CopyFileNoReadOnly(fso, fSource, fDest)

'keyhook.dll
  fSource = AppDir & "\Accessories" & LANG & "\frset\fr14\keyhook.dll"	
	fDest = WSHShell.RegRead("HKCU\Software\Elvos\Common\Path")  & "\oko\keyhook.dll"
	call CopyFileNoReadOnly(fso, fSource, fDest)

	'control.vbs
  fSource = AppDir & "\Accessories" & LANG & "\frset\fr14\control.vbs"	
	fDest = WSHShell.RegRead("HKCU\Software\Elvos\Common\Path")  & "\oko\control.vbs"
	call CopyFileNoReadOnly(fso, fSource, fDest)

  'control.vbs
  fSource = AppDir & "\Accessories" & LANG & "\frset\fr14\control_img.vbs"	
	fDest = WSHShell.RegRead("HKCU\Software\Elvos\Common\Path")  & "\oko\control_img.vbs"
	call CopyFileNoReadOnly(fso, fSource, fDest)
 
  
  'wsh_ui
  fSource = AppDir & "\Accessories" & LANG & "\frset\fr14\wsh_ui.exe"	
	fDest = WSHShell.RegRead("HKCU\Software\Elvos\Common\Path")  & "\oko\wsh_ui.exe"
	call CopyFileNoReadOnly(fso, fSource, fDest)
  Call WSHShell.Run (("""" & fDest  & """" & " /regserver"),1, TRUE) 'register
 
	'--------------------------------
	if (LANG = "\cs") Then
	   'use asist style dialog
      call WSHShell.Run (("""" & AppDir & "\msgrelay.exe" & """" & " " & str102),1, TRUE) 
  end if   
	'--------------------------------
end function

' ------------------------------------------------------------------------
' Vlastni program. 
' Pokud ma program nejaky parameter, zavola se instalace. Parametry se
' predaji metode instal
' ------------------------------------------------------------------------
Set objArgs = Wscript.Arguments
if objArgs.Count > 0 then
	call Install(objArgs)
	Wscript.Quit
end if
' ------------------------------------------------------------------------
' default akce
Set WSHShell = WScript.CreateObject("WScript.Shell")
call WSHShell.PopUp(Info(), , str100, vbOkOnly or vbInformation)
